"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var path_1 = __importDefault(require("path"));
var ora_1 = __importDefault(require("ora"));
var util_1 = require("../util");
var install = function (state) { return __awaiter(void 0, void 0, void 0, function () {
    var currentSpinner, cypressInfo, cypressPackageInfo, cypressUrl, version, zipPath, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                currentSpinner = ora_1.default();
                _a.label = 1;
            case 1:
                _a.trys.push([1, 10, , 11]);
                return [4 /*yield*/, util_1.titleScreen("cypress-tool")];
            case 2:
                _a.sent();
                // * Clear Cypress Cache
                currentSpinner = ora_1.default("Clearing cache").start();
                return [4 /*yield*/, util_1.clearCache()];
            case 3:
                _a.sent();
                currentSpinner.succeed("Cache cleared successfully");
                // * Get Cypress Information
                currentSpinner = ora_1.default("Getting latest Cypress information");
                return [4 /*yield*/, util_1.getCypressInfo()];
            case 4:
                cypressInfo = _a.sent();
                if (!util_1.hasKey(cypressInfo.packages, process.platform)) return [3 /*break*/, 8];
                cypressPackageInfo = cypressInfo.packages[process.platform];
                cypressUrl = cypressPackageInfo.url;
                version = cypressInfo.version;
                zipPath = path_1.default.join(__dirname, "test.zip");
                currentSpinner.succeed("Latest Cypress information received");
                // * Download Cypress.zip for platform
                currentSpinner = ora_1.default("Downloading Cypress v" + version);
                currentSpinner.stopAndPersist();
                return [4 /*yield*/, util_1.downloadCypress(cypressUrl, zipPath)];
            case 5:
                _a.sent();
                currentSpinner.succeed("Cypress v" + version + " downloaded successfully");
                // * Install Cypress from Cypress.zip
                currentSpinner = ora_1.default("Installing Cypress v" + version);
                currentSpinner.stopAndPersist();
                return [4 /*yield*/, util_1.installCypress(version, zipPath)];
            case 6:
                _a.sent();
                currentSpinner.succeed("Cypress v" + version + " installed successfully");
                console.log("");
                console.log(chalk_1.default.blueBright("Press any key to continue..."));
                return [4 /*yield*/, util_1.keypress()];
            case 7:
                _a.sent();
                state.menuActionEmitter.emit("actionCompleted", state);
                return [3 /*break*/, 9];
            case 8:
                console.error(chalk_1.default.red.inverse("No platform found. Platform = " + process.platform));
                console.error("Could not find key (" + process.platform + ") within object (" + JSON.stringify(cypressInfo.packages, null, 2) + ")");
                currentSpinner.fail();
                return [2 /*return*/, process.exit(1)];
            case 9: return [3 /*break*/, 11];
            case 10:
                error_1 = _a.sent();
                currentSpinner.fail();
                console.log(chalk_1.default.inverse.red(error_1));
                return [3 /*break*/, 11];
            case 11: return [2 /*return*/];
        }
    });
}); };
exports.default = install;
