"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var clear_1 = __importDefault(require("clear"));
var configstore_1 = __importDefault(require("configstore"));
var events_1 = __importDefault(require("events"));
var menu_1 = require("./menu");
var setup_1 = __importDefault(require("./setup"));
var util_1 = require("./util");
/**
 * Main Program.
 */
var main = function () { return __awaiter(void 0, void 0, void 0, function () {
    var menuActionEmitter, config, state, isSetUp, e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                // * Needed for cert error
                process.env.NODE_TLS_REJECT_UNAUTHORIZED = "0";
                // * Supress warnings
                process.env.NODE_NO_WARNINGS = "1";
                menuActionEmitter = new events_1.default.EventEmitter();
                menuActionEmitter.on("actionCompleted", function (state) { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: 
                            // * Display title screen
                            return [4 /*yield*/, util_1.titleScreen("cypress-tool")];
                            case 1:
                                // * Display title screen
                                _a.sent();
                                // * Display main menu
                                return [4 /*yield*/, menu_1.displayMainMenu(state)];
                            case 2:
                                // * Display main menu
                                _a.sent();
                                // * When user makes a choice, interpret the choice as an action
                                return [4 /*yield*/, menu_1.interpretMenuAction(state)];
                            case 3:
                                // * When user makes a choice, interpret the choice as an action
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); });
                config = new configstore_1.default("cypress-tool");
                state = {
                    config: config,
                    menuAction: null,
                    menuActionEmitter: menuActionEmitter,
                };
                _a.label = 1;
            case 1:
                _a.trys.push([1, 7, , 8]);
                isSetUp = config.get("isSetUp");
                if (!!isSetUp) return [3 /*break*/, 3];
                // * The user has not gone through a setup process
                // * Set up the user
                return [4 /*yield*/, setup_1.default(state)];
            case 2:
                // * The user has not gone through a setup process
                // * Set up the user
                _a.sent();
                clear_1.default();
                _a.label = 3;
            case 3: return [4 /*yield*/, util_1.titleScreen("cypress-tool")];
            case 4:
                _a.sent();
                return [4 /*yield*/, menu_1.displayMainMenu(state)];
            case 5:
                _a.sent();
                return [4 /*yield*/, menu_1.interpretMenuAction(state)];
            case 6:
                _a.sent();
                return [3 /*break*/, 8];
            case 7:
                e_1 = _a.sent();
                console.error("ERROR");
                console.log(state);
                console.error(e_1);
                return [3 /*break*/, 8];
            case 8: return [2 /*return*/];
        }
    });
}); };
// * Handle local development with `npm start`
if (process.argv[3] === "start")
    main();
exports.default = main;
