"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasKey = exports.installCypress = exports.downloadCypress = exports.getCypressInfo = exports.clearCache = exports.getCacheLocation = exports.executeCommand = exports.titleScreen = exports.keypress = exports.defaultBoxenStyle = exports.blankBoxenStyle = void 0;
var boxen_1 = __importStar(require("boxen"));
var chalk_1 = __importDefault(require("chalk"));
var clear_1 = __importDefault(require("clear"));
var node_fetch_1 = __importDefault(require("node-fetch"));
var figlet_1 = __importDefault(require("figlet"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var https_proxy_agent_1 = __importDefault(require("https-proxy-agent"));
var path_1 = __importDefault(require("path"));
var progress_1 = __importDefault(require("progress"));
var child_process_1 = require("child_process");
/**
 * Blank style applied to Boxen.
 */
exports.blankBoxenStyle = {
    borderStyle: {
        topLeft: " ",
        topRight: " ",
        bottomLeft: " ",
        bottomRight: " ",
        horizontal: " ",
        vertical: " ",
    },
    float: "center",
    padding: { top: 0, bottom: 0, right: 1, left: 1 },
};
/**
 * Default style applied to Boxen.
 */
exports.defaultBoxenStyle = {
    borderColor: "magentaBright",
    borderStyle: "round" /* Round */,
    float: "center",
    padding: { top: 0, bottom: 0, right: 1, left: 1 },
};
/**
 * Uses Figlet to transform your text to ASCII.
 * @param {String} txt Text to be figlet-itized.
 * @param {Object} options Options object.
 * @returns {Promise} Resolves with text.
 */
var figletPromise = function (txt, options) {
    return new Promise(function (resolve, reject) {
        return figlet_1.default.text(txt, options, function (error, result) {
            if (error) {
                return reject(error);
            }
            resolve(result);
        });
    });
};
/**
 * Pauses the process execution and waits for the user to hit a key.
 * @returns {Promise} Resolves when user has entered a keystroke.
 * @async
 */
exports.keypress = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        try {
            process.stdin.setRawMode(true);
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    try {
                        process.stdin.resume();
                        process.stdin.once("data", function () {
                            process.stdin.setRawMode(false);
                            resolve();
                        });
                    }
                    catch (e) {
                        return reject(e);
                    }
                })];
        }
        catch (e) {
            throw new Error(e);
        }
        return [2 /*return*/];
    });
}); };
/**
 * Displays a title in the center of the terminal.
 * @param {String} title Title to be disaplayed.
 * @returns {Promise} Resolves after logging to the console.
 */
exports.titleScreen = function (title) {
    return new Promise(function (resolve, reject) { return __awaiter(void 0, void 0, void 0, function () {
        var text, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, figletPromise(title, {
                            font: "Slant",
                        })];
                case 1:
                    text = _a.sent();
                    clear_1.default();
                    console.log(boxen_1.default(chalk_1.default.blueBright(text), exports.defaultBoxenStyle));
                    resolve();
                    return [3 /*break*/, 3];
                case 2:
                    e_1 = _a.sent();
                    reject(e_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
};
exports.default = exports.titleScreen;
/**
 * Executes a command in a spawned process.
 * @param command Command to execute in the process.
 * @param args Additional arguments to attach to the command.
 * @param options Optional options object to pass along.
 * @param debug Optional logging of output.
 */
exports.executeCommand = function (command, args, options, dataParser, debug) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve, reject) {
                var cp = child_process_1.spawn(command, args, options);
                if (debug) {
                    cp.stdout.on("data", function (data) { return console.log("stdout: " + data); });
                    cp.stderr.on("data", function (data) { return console.log("stderr: " + data); });
                }
                if (dataParser) {
                    cp.stdout.on("data", dataParser);
                }
                cp.on("error", function (err) {
                    if (err) {
                        console.log("");
                        console.log(err);
                        reject(err.message);
                    }
                });
                cp.on("exit", function (code, signal) {
                    if (code !== 0) {
                        console.log("");
                        reject({ args: args, command: command, code: code, signal: signal, options: options });
                    }
                    resolve();
                });
                cp.on("message", function (message) { return console.log({ message: message }); });
            })];
    });
}); };
exports.getCacheLocation = function () {
    var cacheLocation = "";
    if (process.platform === "darwin") {
        if (!process.env.HOME) {
            console.log(chalk_1.default.red.inverse("No `process.env.HOME`"));
            return process.exit(1);
        }
        cacheLocation = path_1.default.join(process.env.HOME, "/Library/Caches/Cypress");
    }
    else {
        if (!process.env.TEMP) {
            console.log(chalk_1.default.red.inverse("No `process.env.TEMP`"));
            return process.exit(1);
        }
        cacheLocation = path_1.default.join(process.env.TEMP, "..", "Cypress/Cache");
    }
    return cacheLocation;
};
exports.clearCache = function () {
    return new Promise(function (resolve, reject) { return __awaiter(void 0, void 0, void 0, function () {
        var cacheLocation_1, cacheContents, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    cacheLocation_1 = exports.getCacheLocation();
                    return [4 /*yield*/, fs_extra_1.default.readdir(cacheLocation_1)];
                case 1:
                    cacheContents = _a.sent();
                    return [4 /*yield*/, Promise.all(cacheContents.map(function (cacheDirName) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, fs_extra_1.default.remove(path_1.default.join(cacheLocation_1, cacheDirName))];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 2:
                    _a.sent();
                    resolve();
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    reject(error_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
};
// * Agent used for network requests
var agent = process.env.HTTP_PROXY
    ? new https_proxy_agent_1.default(process.env.HTTP_PROXY)
    : undefined;
exports.getCypressInfo = function () { return __awaiter(void 0, void 0, void 0, function () {
    var response, cypressInfo;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, node_fetch_1.default("https://download.cypress.io/desktop.json", {
                    agent: agent,
                    headers: { "Content-Type": "application/json" },
                    method: "GET",
                })];
            case 1:
                response = _a.sent();
                return [4 /*yield*/, response.json()];
            case 2:
                cypressInfo = _a.sent();
                return [2 /*return*/, cypressInfo];
        }
    });
}); };
exports.downloadCypress = function (cypressUrl, zipPath) {
    return new Promise(function (resolve, reject) { return __awaiter(void 0, void 0, void 0, function () {
        var response, contentLength, bar, fileStream;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, node_fetch_1.default(cypressUrl, { agent: agent, method: "GET" })];
                case 1:
                    response = _a.sent();
                    contentLength = response.headers.get("content-length");
                    bar = new progress_1.default("Downloading [:bar] :percent :etas", {
                        complete: "=",
                        incomplete: " ",
                        width: 50,
                        total: Number(contentLength),
                    });
                    fileStream = fs_extra_1.default.createWriteStream(zipPath);
                    response.body.pipe(fileStream);
                    response.body.on("error", function (err) { return reject(err); });
                    response.body.on("data", function (chunk) { return bar.tick(chunk.length); });
                    fileStream.on("finish", function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                        return [2 /*return*/, resolve()];
                    }); }); });
                    return [2 /*return*/];
            }
        });
    }); });
};
exports.installCypress = function (version, zipPath) {
    return new Promise(function (resolve, reject) { return __awaiter(void 0, void 0, void 0, function () {
        var installBar_1, installationCompleted_1, parseInstallData, error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    installBar_1 = new progress_1.default("Installing [:bar] :percent :etas", {
                        complete: "=",
                        incomplete: " ",
                        width: 50,
                        total: 100,
                    });
                    installationCompleted_1 = false;
                    parseInstallData = function (data) {
                        var stringData = data.toString();
                        var percentCompleteDigit1 = stringData.match(/\d%/gm);
                        var percentCompleteDigit2 = stringData.match(/\d\d%/gm);
                        var percentCompleteDigit3 = stringData.match(/\d\d\d%/gm);
                        var percentComplete = percentCompleteDigit3
                            ? percentCompleteDigit3
                            : percentCompleteDigit2
                                ? percentCompleteDigit2
                                : percentCompleteDigit1;
                        var number = Number(percentComplete === null || percentComplete === void 0 ? void 0 : percentComplete.toString().replace(/%/gm, "")) || 1;
                        if (number === 100) {
                            installationCompleted_1 = true;
                        }
                        if (installationCompleted_1) {
                            if (!installBar_1.complete) {
                                installBar_1.update(1);
                            }
                        }
                        else {
                            installBar_1.update(number / 100);
                        }
                    };
                    return [4 /*yield*/, exports.executeCommand("npm", ["install", "-D", "cypress@" + version], {
                            env: __assign(__assign({}, process.env), { CYPRESS_INSTALL_BINARY: zipPath }),
                            path: undefined,
                            shell: process.platform === "win32",
                        }, parseInstallData)];
                case 1:
                    _a.sent();
                    resolve();
                    return [3 /*break*/, 3];
                case 2:
                    error_2 = _a.sent();
                    reject(error_2);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
};
/**
 * https://dev.to/kingdaro/indexing-objects-in-typescript-1cgi
 */
exports.hasKey = function (obj, key) {
    return key in obj;
};
